﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2015 Joseph Helm and Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using HeuristicLab.Problems.BinPacking.Interfaces;
using HeuristicLab.Problems.BinPacking.Shapes;
using HeuristicLab.Core;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
using HeuristicLab.Common;

namespace HeuristicLab.Problems.BinPacking.PackingBin {
  [Item("RectangularPackingBin", "Represents a rectangular bin for a two-dimensional bin-packing problem.")]
  [StorableClass]
  public class RectangularPackingBin : RectangularPackingShape, IPackingBin {

    public RectangularPackingBin(int width, int height) : base(width, height) { }
    public RectangularPackingBin()
      : base() {

    }

    [StorableConstructor]
    protected RectangularPackingBin(bool deserializing) : base(deserializing) { }
    protected RectangularPackingBin(RectangularPackingBin original, Cloner cloner)
      : base(original, cloner) {
    }
    public override IDeepCloneable Clone(Cloner cloner) {
      return new RectangularPackingBin(this, cloner);
    }
  }
}
